var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
  get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
}) : x)(function(x) {
  if (typeof require !== "undefined")
    return require.apply(this, arguments);
  throw Error('Dynamic require of "' + x + '" is not supported');
});

// src/index.ts
import { Plugin } from "zhin";
import { createServer } from "http";
import Koa from "koa";
import auth from "koa-basic-auth";
import KoaBodyParser from "koa-bodyparser";

// src/router.ts
import { remove } from "zhin";
import { WebSocketServer } from "ws";
import { parse } from "url";
var KoaRouter = __require("@koa/router");
var Router = class extends KoaRouter {
  //用于historyApi排除
  constructor(server2, options) {
    super(options);
    this.server = server2;
    this.wsStack = [];
    this.whiteList = [];
  }
  register(...args) {
    const path = args[0];
    this.whiteList.push(path);
    return super.register(...args);
  }
  destroy(layer) {
    remove(this.stack, layer);
  }
  destroyWs(wsServer) {
    wsServer.close();
    remove(this.wsStack, wsServer);
  }
  ws(path, options = {}) {
    const wsServer = new WebSocketServer({
      noServer: true,
      path,
      ...options
    });
    this.wsStack.push(wsServer);
    this.server.on("upgrade", (request, socket, head) => {
      const { pathname } = parse(request.url);
      if (this.wsStack.findIndex((wss) => wss.options.path === path) === -1) {
        socket.destroy();
      } else if (pathname === path) {
        wsServer.handleUpgrade(request, socket, head, (ws) => {
          wsServer.emit("connection", ws, request);
        });
      }
    });
    return wsServer;
  }
};

// src/index.ts
import * as process from "process";
var koa = new Koa();
var username = process.env.username || "admin";
var password = process.env.password || "123456";
koa.use(
  auth({
    name: username,
    pass: password
  })
);
var server = createServer(koa.callback());
var router = new Router(server, { prefix: process.env.routerPrefix || "" });
var outputCommand = (command) => {
  return {
    name: command.name,
    desc: command.config.desc,
    alias: command.aliasNames,
    hidden: command.config.hidden,
    help: command.help()
  };
};
router.get("/api/plugins", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = httpServer.app.pluginList.map((plugin) => {
    return {
      full_name: plugin.name,
      display_name: plugin.display_name,
      status: plugin.status,
      middlewareCount: plugin.middlewares.length,
      commands: [...plugin.commands.values()].map(outputCommand),
      services: [...plugin.services.entries()].map(([name]) => name)
    };
  });
});
router.get("/api/plugin/:name/commands", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = [...httpServer.app?.plugins.get(ctx.params.name)?.commands.values() || []].map(outputCommand);
});
router.get("/api/config", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = httpServer.app.config;
});
router.get("/api/adapters", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = [...httpServer.app.adapters.values()].map((adapter) => {
    return {
      name: adapter.name,
      bots: adapter.bots.map((bot) => {
        return bot.unique_id;
      })
    };
  });
});
router.get("/api/adapter/:name/bots", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = httpServer.app?.adapters.get(ctx.params.name)?.bots.map((bot) => {
    return bot.unique_id;
  }) || [];
});
router.get("/api/bots", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = [...httpServer.app?.adapters.values() || []].reduce((result, adp) => {
    return result.concat(
      adp.bots.map((bot) => {
        return bot.unique_id;
      })
    );
  }, []);
});
router.get("/api/commands", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = [...httpServer.app.commandList].map(outputCommand);
});
var httpServer = new Plugin("http-server");
httpServer.service("server", server).service("koa", koa).service("router", router);
koa.use(KoaBodyParser()).use(router.routes()).use(router.allowedMethods());
var _a;
server.listen(
  {
    host: "0.0.0.0",
    port: Number((_a = process.env).port || (_a.port = "8086"))
  },
  () => {
    const address = server.address();
    if (!address)
      return;
    httpServer.app?.logger.mark("server start at", address);
    httpServer.app?.logger.info("your username is\uFF1A", username);
    httpServer.app?.logger.info("your password is\uFF1A", password);
  }
);
httpServer.on("plugin-beforeUnmount", () => {
  server.close();
});
var src_default = httpServer;
export {
  Router,
  src_default as default
};
